import React, { HTMLAttributes } from "react";
export interface DialogContentProps extends HTMLAttributes<HTMLDivElement> {
    /**
     * Boolean if the default padding for the content should be removed. This is
     * helpful when the child elements already have the required padding (such as lists).
     * In all other cases, it is recommended to apply a custom className with the
     * padding overrides instead.
     */
    disablePadding?: boolean;
}
declare const _default: React.ForwardRefExoticComponent<DialogContentProps & React.RefAttributes<HTMLDivElement>>;
export default _default;
